package sos.xml;

import java.io.ByteArrayInputStream;
import java.io.FileInputStream;


import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.apache.xpath.CachedXPathAPI;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import org.xml.sax.InputSource;


/**
 * @author ap
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class SOSXMLXPath extends CachedXPathAPI {

	public Document document = null;
	public Element root = null;
	public Node node = null;

	public static void main(String[] args) {
		
		try { 
			// SOSXMLXPath xpath = new SOSXMLXPath("c:/factory/custom/ecb/ecb_order_transformed.xml");
			// String astring = xpath.selectSingleNodeValue("//Model");
			// System.out.println("model: "+ astring);

		    SOSXMLXPath xpath = new SOSXMLXPath(new StringBuffer("<spooler><answer><ERROR code=\"4711\" text=\"ein Fehler\"/></answer></spooler>"));
			String astring = xpath.selectSingleNodeValue("//ERROR/@code");
			String bstring = xpath.selectSingleNodeValue("//ERROR/@text");
			System.out.println("code: "+ astring + " text: " + bstring);
		} catch (Exception e) {}
	}
	
	
    public SOSXMLXPath(StringBuffer xmlStr) throws Exception {
        
        super();
		DocumentBuilderFactory docFactory = DocumentBuilderFactory.newInstance();
		docFactory.setNamespaceAware(false);
		docFactory.setValidating(false);
		DocumentBuilder docBuilder = docFactory.newDocumentBuilder();
		this.document = docBuilder.parse(new ByteArrayInputStream(xmlStr.toString().getBytes()));
		this.root = this.document.getDocumentElement();
    }
	
	
	public SOSXMLXPath(String filename) throws Exception {

		super();
		InputSource in = new InputSource(new FileInputStream(filename));

		DocumentBuilderFactory docFactory = DocumentBuilderFactory.newInstance();
		docFactory.setNamespaceAware(false);
		docFactory.setValidating(false);
		DocumentBuilder docBuilder = docFactory.newDocumentBuilder();
		this.document = docFactory.newDocumentBuilder().parse(in);
		this.root = this.document.getDocumentElement();
	}

	

	public String selectSingleNodeValue(String xpathExpression) throws Exception {
		
		return selectSingleNodeValue(this.document.getDocumentElement(), xpathExpression);
	}

	
	public String selectSingleNodeValue(Element element, String xpathExpression) throws Exception {
		
		Node node = this.selectSingleNode(element, xpathExpression);
		if (node != null) return this.getNodeText(node);
 
		return null;
	}
	
    /**
     * erzeugt ein XML-Dokument
     * @param nodeName Name des Startknotens
     */
/*	
    private Document createDocument() 
    	throws Exception {
        
        try {
            DocumentBuilderFactory docFactory = DocumentBuilderFactory.newInstance();
            docFactory.setNamespaceAware(true);
            DocumentBuilder docBuilder = docFactory.newDocumentBuilder();
            this.document = docBuilder.newDocument();

            return this.document;
            
        } catch (Exception e) {
            throw new Exception(SOSClassUtil.getMethodName() + ": " + e.toString());
        }
    }
    */
    /**
     * erzeugt ein XML-Dokument
     * @param nodeName Name des Startknotens
     */
/*	
    private Document createDocument(String nodeName) 
    	throws Exception {
        
        try {
            DocumentBuilderFactory docFactory = DocumentBuilderFactory.newInstance();
            docFactory.setNamespaceAware(true);
            DocumentBuilder docBuilder = docFactory.newDocumentBuilder();
            this.document = docBuilder.newDocument();

			this.node = this.document.createElement(nodeName);
            
            return this.document;
            
        } catch (Exception e) {
            throw new Exception(SOSClassUtil.getMethodName() + ": " + e.toString());
        }
    }
*/    
    /**
     * schliet ein XML-Dokument
     */
/*	
    private Document closeDocument() 
    	throws Exception {

        try {
            this.document.appendChild(this.node);
            return this.document;
            
        } catch (Exception e) {
            throw new Exception(SOSClassUtil.getMethodName() + ": " + e.toString());
        }
    }
*/    
    /**
     * liefert das XML-Dokument
     */
    public Document getDocument()
    	throws Exception {
        
         return this.document;
    }
    
    /**
     * liefert das XML-Dokument
     */
	
    public Element getElement()
    	throws Exception {

    	return (Element)this.node;
    }

    
    public String getNodeText(Node node)
    {
    	String strRet = "";
    		
    	if (null != node)
    	{
    		NodeList children = node.getChildNodes();
    		for (int i = 0; i < children.getLength(); ++i)
    		{
    			Node item = children.item(i);
    			switch (item.getNodeType())
    			{
    			case Node.TEXT_NODE:
    			case Node.CDATA_SECTION_NODE:
    				strRet += item.getNodeValue();
    			}
    		}
    	}
    		
    	return strRet;
    }

}
