// $Id: Process_with_pid.java 3303 2005-01-11 23:22:22Z jz $

package sos.hostware;

import java.lang.*;
import java.io.*;


/**
 * @author Joacim Zschimmer
 */

public class Process_with_pid  extends java.lang.Process
{
    public Process_with_pid( String command_line )  throws Exception
    { 
        _reference = start( command_line );
    }


    public Process_with_pid( String[] program_and_parameters )  throws Exception
    { 
        _reference = start_array( program_and_parameters );
    }


    
    protected void finalize()  throws Throwable
    {
        try
        {
            close();
        }
        finally
        {
            super.finalize();
        }
    }


    
    public void close()
    {
        if( _reference != 0 )
        {
            try
            {
                close( _reference );
            }
            finally
            {
                _reference = 0;
            }
        }
    }


    public void                 destroy                     ()                          {        destroy   ( _reference ); }
    public int                  waitFor                     ()                          { return waitFor   ( _reference ); }
    public boolean              terminated                  ()                          { return terminated( _reference ); }
    public int                  exitValue                   ()                          { return exitValue ( _reference ); }
    public int                  pid                         ()                          { return pid       ( _reference ); }

    public        InputStream   getErrorStream              ()                          { throw new Error( "getErrorStream() ist nicht implementiert" ); }      
    public        InputStream   getInputStream              ()                          { throw new Error( "getInputStream() ist nicht implementiert" ); }      
    public        OutputStream  getOutputStream             ()                          { throw new Error( "getOutputStream() ist nicht implementiert" ); }      



    private native void         destroy                     ( long reference );
    private native long         start                       ( String command_line );
    private native long         start_array                 ( String[] program_and_parameters );
    private native void         close                       ( long reference );
    private native int          waitFor                     ( long reference );
    private native boolean      terminated                  ( long reference );
    private native int          exitValue                   ( long reference );
    private native int          pid                         ( long reference );
    public  static native void  kill_pid                    ( int pid );
    public  static native boolean try_kill_pid              ( int pid );
    
    private long               _reference                   = 0;


    static
    {
        System.loadLibrary("hostjava");
    }
};
