// $Id: z_process.cxx 3813 2005-08-01 08:57:29Z jz $

#include "zschimmer.h"
#include "log.h"
#include "z_process.h"


namespace zschimmer {


//-------------------------------------------------------------------------------------------------

static Error_code_text error_codes[] =
{
    { "Z-PROCESS-001", "Prozess $1 hat noch nicht geendet oder wait_for_termination() ist nicht gerufen worden" },
    { "Z-PROCESS-002", "Prozess ist bereits gestartet worden" },
    {}
};

//-------------------------------------------------------------------------------------------Z_INIT

Z_INIT( z_process )
{
    add_error_code_texts( error_codes ); 
}

//----------------------------------------------------------------------Process_base::~Process_base

Process_base::~Process_base()
{
    // Nicht inline, damit z_process.cxx mit error_codes eingebunden wird.
}

//---------------------------------------------------------------------try_kill_process_immediately

bool try_kill_process_immediately( int pid, bool kill_descendants )
{
    bool result = true;

    try
    {
/*
#       ifdef Z_WINDOWS

            kill_process_immediately( pid, false );

            if( kill_descendants )
            {
                vector<int> descendants = windows::get_child_pids( pid, true );
                Z_FOR_EACH( vector<int>, descendants, d )  result &= try_kill_process_immediately( pid, false );
            }

#       else
*/
            kill_process_immediately( pid, kill_descendants );

//#       endif
    }
    catch( const exception& ) 
    {
        result = false;
    }

    return result;
}

//-------------------------------------------------------------------------------------------------

} //namespace zschimmer

