// $Id: z_windows_process.h 3813 2005-08-01 08:57:29Z jz $

#ifndef __ZSCHIMMER_WINDOWS_PROCESS_H
#define __ZSCHIMMER_WINDOWS_PROCESS_H


#include "z_windows.h"


namespace zschimmer {

//---------------------------------------------------------------------try_kill_process_immediately
    
bool                            try_kill_process_immediately( Process_handle );
void                            kill_process_immediately    ( Process_handle );

//-------------------------------------------------------------------------------------------------

namespace windows {

//-------------------------------------------------------------------------------------------------
    
std::vector<int>                get_child_pids              ( int parent_pid, bool with_descendants = false );

//------------------------------------------------------------------------------------------Process

struct Process : Process_base, Handle
{
                                Process                     ();
                                Process                     ( int pid )                             : _zero_(this+1) { init(); attach_pid( pid ); }

    void                        init                        ();

    STDMETHODIMP            put_Priority_class              ( VARIANT* priority )                   { Z_COM_IMPLEMENT( set_priority_class( com::string_from_variant( *priority ) ) ); } 
    STDMETHODIMP            get_Priority_class              ( BSTR* result )                        { Z_COM_IMPLEMENT( hr = com::String_to_bstr( priority_class(), result ) ); } 

    void                        close                       ();
    void                        start                       ( const string& command_line );
    void                        start                       ( const std::vector<string>& program_and_parameters );
  //void                    set_startup_info                ( const STARTUP_INFO si )               { _startup_info = si; );
    void                        attach_handle               ( HANDLE handle, int pid )              { _handle = handle;  _pid = pid; }
    void                        attach_pid                  ( int pid );
    bool                    set_priority                    ( int );
    int                         priority                    ();
  //virtual void            set_with_console_window         ( bool b )                              { _with_console_window = b; }
    bool                    set_priority_class              ( int );                                // NORMAL_PRIORITY_CLASS etc.
    bool                    set_priority_class              ( const string& );
    string                      priority_class              ();
  //bool                        raise_priority              ( int difference );
    void                        wait                        ();
    bool                        wait                        ( double seconds );                     // Nicht in Unix
    bool                        terminated                  ();
    int                         exit_code                   ();
    int                         termination_signal          ()                                      { return 0; }   // Windows kennt nur exit_code
    void                        kill                        ( int signal = 99 );
    bool                        try_kill                    ( int signal = 99 );
    string                      obj_name                    ();
    HANDLE                      take_handle                 ()                                      { HANDLE result = _handle;  _handle = NULL, _pid = 0;  return result; }
    bool                        opened                      () const                                { return _handle != 0; }


    Fill_zero                  _zero_;
    STARTUPINFO                _startup_info;
    
  private:
    string                      make_environment_string     ();

    int                        _priority_class;
  //bool                       _with_console_window;
  //bool                       _raise_priority_set;
  //int                        _raise_priority;
};

//--------------------------------------------------------------------------------------Process_ref
/*
struct Process_ref : Process
{
                                Process_ref                 ( HANDLE handle )                       { attach_handle( handle ); }
                               ~Process_ref                 ()                                      { _handle = NULL; }
};
*/
//-------------------------------------------------------------------------------------------------

} //namespace windows

//-------------------------------------------------------------------------------------------------
} //namespace zschimmer

#endif
